import React, { useCallback, useEffect, useRef, useState } from "react";
import styles from "./index.module.scss";
import { Button, DatePicker, Form, FormInstance, Input } from "antd";
import { A2_APIgetInfo, A2_APIsave } from "@/store/action/A2dynamic";
import dayjs from "dayjs";
import { useDispatch, useSelector } from "react-redux";
import { Z0_APIgetList } from "@/store/action/Z0column";
import { RootState } from "@/store";
import { Select } from "antd/lib";
import TextArea from "antd/es/input/TextArea";
import MyPopconfirm from "@/components/MyPopconfirm";
import ZRichText from "@/components/ZRichText";
import ZupOne from "@/components/ZupOne";
import ZupVideos from "@/components/ZupVideos";
import { MessageFu } from "@/utils/message";

type Props = {
  editId: number;
  addTableFu: () => void;
  editTableFu: () => void;
  closeFu: () => void;
};

function A2edit({ editId, addTableFu, editTableFu, closeFu }: Props) {
  const [dirCode, setDirCode] = useState("");

  const dispatch = useDispatch();
  // 获取所属栏目列表，用于下拉框
  useEffect(() => {
    dispatch(Z0_APIgetList());
  }, [dispatch]);

  const { dynamic } = useSelector(
    (state: RootState) => state.Z0column.tableInfo
  );

  // 表单的ref
  const FormBoxRef = useRef<FormInstance>(null);

  // 封面图的ref
  const ZupThumbRef = useRef<any>(null);
  // 富文本的ref
  const ZRichTextRef = useRef<any>(null);
  //  视频的ref
  const ZupVideosRef = useRef<any>(null);

  const getInfoFu = useCallback(async (id: number) => {
    const res = await A2_APIgetInfo(id);
    if (res.code === 0) {
      const data = res.data;

      setDirCode(data.dirCode);

      ZRichTextRef.current?.ritxtShowFu(data.rtf);

      FormBoxRef.current?.setFieldsValue({
        ...data,
        myTime: dayjs(data.publishDate),
      });

      // 设置封面图
      ZupThumbRef.current?.setFileComFileFu({
        fileName: "",
        filePath: data.thumb,
      });

      // 设置附件视频
      ZupVideosRef.current?.setFileComFileFu(res.data.files || []);
    }
  }, []);

  useEffect(() => {
    if (editId > 0) {
      setDirCode(Date.now() + "");
      getInfoFu(editId);
    } else {
      FormBoxRef.current?.setFieldsValue({
        myTime: dayjs(Date.now()),
      });
    }
  }, [editId, getInfoFu]);

  // 附件 是否 已经点击过确定
  const [fileCheck, setFileCheck] = useState(false);

  // 没有通过校验
  const onFinishFailed = useCallback(() => {
    setFileCheck(true);
  }, []);

  // 待完善 type 所属栏目

  //  通过校验点击确定
  const onFinish = useCallback(
    async (values: any) => {
      setFileCheck(true);

      const coverUrl1 = ZupThumbRef.current?.fileComFileResFu();
      // 没有传 封面图
      if (!coverUrl1.filePath) return;
      // 发布日期
      const publishDate = dayjs(values.myTime).format("YYYY-MM-DD");

      const rtf = ZRichTextRef.current?.fatherBtnOkFu();

      const flieList = ZupVideosRef.current?.fileComFileResFu() || [];

      const obj = {
        ...values,
        id: editId > 0 ? editId : null,
        publishDate,
        thumb: coverUrl1.filePath,
        rtf: rtf.val,
        fileIds: flieList.map((v: any) => v.id).join(","),
      };

      const res = await A2_APIsave(obj);

      if (res.code === 0) {
        MessageFu.success(editId > 0 ? "编辑成功!" : "新增成功!");
        editId > 0 ? editTableFu() : addTableFu();
        closeFu();
      }
    },
    [addTableFu, closeFu, editId, editTableFu]
  );
  return (
    <div className={styles.A2edit}>
      <div className="A2eMain">
        <Form
          ref={FormBoxRef}
          name="basic"
          labelCol={{ span: 3 }}
          onFinish={onFinish}
          onFinishFailed={onFinishFailed}
          autoComplete="off"
          scrollToFirstError
        >
          <Form.Item
            label="标题"
            name="name"
            rules={[{ required: true, message: "请输入标题!" }]}
            getValueFromEvent={(e) => e.target.value.replace(/\s+/g, "")}
          >
            <Input maxLength={30} showCount placeholder="请输入内容" />
          </Form.Item>

          <Form.Item
            label="发布日期"
            name="myTime"
            rules={[{ required: true, message: "请选择发布日期!" }]}
          >
            <DatePicker />
          </Form.Item>

          <Form.Item
            label="所属栏目"
            name="type"
            rules={[{ required: true, message: "请选择发布日期!" }]}
          >
            <Select
              placeholder="请选择"
              style={{ width: 200 }}
              options={dynamic.map((v) => ({ value: v.id, label: v.name }))}
            />
          </Form.Item>

          {/* 封面 */}
          <div className="formRow">
            <div className="formLeft">
              <span>* </span>
              封面图：
            </div>
            <div className="formRight">
              <ZupOne
                ref={ZupThumbRef}
                isLook={false}
                fileCheck={fileCheck}
                size={5}
                dirCode={dirCode}
                myUrl="cms/news/upload"
                format={["image/jpeg", "image/png"]}
                formatTxt="png、jpg和jpeg"
                checkTxt="请上传封面图!"
                upTxt="最多1张"
                myType="thumb"
              />
            </div>
          </div>

          {/* 视频 */}
          <div className="formRow">
            <div className="formLeft">视频：</div>
            <div className="formRight">
              <ZupVideos
                isLook={false}
                size={500}
                fileNum={5}
                dirCode={dirCode}
                myUrl="cms/overview/upload"
                upTxt="；数量不超过5个。"
                ref={ZupVideosRef}
              />
            </div>
          </div>

          <Form.Item label="摘要" name="description">
            <TextArea maxLength={200} showCount placeholder="请输入内容" />
          </Form.Item>

          {/* 富文本 */}
          <div className="formRow">
            <div className="formLeft">正文：</div>
            <div className="formRight" style={{height:450}}>
              <ZRichText
                check={false}
                dirCode={dirCode}
                isLook={false}
                ref={ZRichTextRef}
                myUrl="cms/news/upload"
              />
            </div>
          </div>

          {/* 确定和取消按钮 */}
          <Form.Item className="A2Ebtn">
            <Button type="primary" htmlType="submit">
              提交
            </Button>
            <br />
            <br />
            <MyPopconfirm txtK="取消" onConfirm={closeFu} />
          </Form.Item>
        </Form>
      </div>
    </div>
  );
}

const MemoA2edit = React.memo(A2edit);

export default MemoA2edit;
